Subject: Re: [PATCH v5 4/7] can: Kconfig: add CONFIG_CAN_RX_OFFLOAD

From: Jakub Kicinski <[email-masked]>
Date: Tue, 7 Jun 2022 17:14:55 -0700

On Wed, 8 Jun 2022 01:43:54 +0200 Max Staudt wrote:
> It seems strange to me to magically build some extra features into
> can_dev.ko, depending on whether some other .ko files are built in that
> very same moment, or not. By "magically", I mean an invisible Kconfig
> option. This is why I think Vincent's approach is best here, by making
> the drivers a clearly visible subset of the RX_OFFLOAD option in
> Kconfig, and RX_OFFLOAD user-selectable.

Sorry for a chunked response, vger becoming unresponsive the week after
the merge window seems to become a tradition :/

We have a ton of "magical" / hidden Kconfigs in networking, take a look
at net/Kconfig. Quick grep, likely not very accurate but FWIW:

# not-hidden
$ git grep -c -E '(bool|tristate)..' net/Kconfig
net/Kconfig:23

# hidden
$ git grep -c -E '(bool|tristate)$' net/Kconfig
net/Kconfig:20

> How about making RX_OFFLOAD a separate .ko file, so we don't have
> various possible versions of can_dev.ko?
> 
> @Vincent, I think you suggested that some time ago, IIRC?
> 
> (I know, I was against a ton of little modules, but I'm changing my
> ways here now since it seems to help...)

A separate module wouldn't help with my objections, I don't think.